//----------------------
// C
//      CIP version 2.0
//----------------------

#include <stdio.h>
#include "init.h"
#include "syswork.h"
#include "game.h"
#include "pad.h"
#include "ascii.h"
#include "sound.h"

#if DEBUG
//----------------------
// ʒɕו\
//----------------------
void draw_loadaverage(int avg,GsOT*got)
{
    GsLINE line;

    line.r = 255;
    line.g = line.b = 0;
    line.x0 = 0;
    line.y0 = TOP;
    line.x1 = 0;
    line.y1 = TOP+avg;
    GsSortLine(&line,got,0);
}
#endif

#if DEBUG
//----------------------------
// t[obt@̓emF
//----------------------------
static void Vframebuff()
{
    SYS_W*sysw=GetSystemWorkAddr();
    int x=0,y=0;
    while(1){
        getpad();
        if(sysw->padw[PAD2].new & PADselect) break;
        if(sysw->padw[PAD2].new & PADLup) y--;
        if(sysw->padw[PAD2].new & PADLdown) y++;
        if(sysw->padw[PAD2].new & PADLright) x++;
        if(sysw->padw[PAD2].new & PADLleft) x--;
        GsDefDispBuff(x,y,x,y);
        GsSwapDispBuff();
    }
    GsDefDispBuff(FRAME_X1, FRAME_Y1, FRAME_X2, FRAME_Y2);
    GsSwapDispBuff();
}
#endif

int main()
{
    SYS_W*sysw=GetSystemWorkAddr();
#if DEBUG
    OBJ_W*objw=GetObjectWorkAddr();
#endif

    ResetGraph(0);
    init();         // e평(in init.c)

#if DEBUG
    printf("\nsystem work size:0x%x\n",sizeof(SYS_W));
    printf("object work size:0x%x\n",sizeof(OBJ_W));
    printf("total size:0x%x(%d)\n",sizeof(SYS_W)+sizeof(OBJ_W),sizeof(SYS_W)+sizeof(OBJ_W));
    printf("KanjiFntStream:%d\n\n",sysw->fntstream);
    printf("system work top:0x%x\n",SYSWORK_TOP);
    printf("freemem top:0x%x\n",FREEMEM_TOP);
#endif

#ifndef DEBUG
	close(0);
	close(1);
#endif

    while(TRUE){
        sysw->systimer++;

        sysw->activebuff = GsGetActiveBuff();
        GsSetWorkBase((PACKET *)sysw->packet[sysw->activebuff]);
        // OTNA
        GsClearOt(0,0,&(sysw->got[sysw->activebuff]));

#if DEBUG
        //draw_loadaverage(sysw->load,&(sysw->got[sysw->activebuff]));
        gprintf8(0,LEFT,0,"load:%d",sysw->load);
        gprintf8(0,LEFT,8,"objnum:%d",objw->objnum);
	    KsWorldInteractive();
    	// _ύX
	    if(sysw->padw[PAD1].iskeydown & PADselect){
		   	// NEH[^[r[
		    sysw->view.vpx = 0;
			sysw->view.vpy = 0xfffff6a0;
		    sysw->view.vpz = 0xa8c;
			sysw->view.vrx = 0;
			sysw->view.vry = 0xfffffaec;
			sysw->view.vrz = 0;
		    sysw->view.rz=0;
	    }
/*
	gprintf8(0,0,0,"HIT RATE %d%%(%d/%d)",sysw->numofhit?(sysw->numofhit*100/sysw->numofattack):0,(sysw->numofhit),(sysw->numofattack));
	gprintf8(0,0,8,"DAMAGE %d",sysw->numofdamage);
	gprintf8(0,0,16,"TIME %d sec.",((sysw->systimer-sysw->g_start)/30));
*/
#endif

        // [h/XN[ϊ}gNXvZ
        GsSetRefView2(&sysw->view);

        // Q[C
        gamemain();
	    ks_obj_sys();

        // 2 hsync by 1 kanji-charactor(114 upto 145)
        //KanjiFntPrint(sysw->fntstream,"͂ɂPXƂo܂");

        DrawSync(0);
        sysw->load = VSync(0);
		if((sysw->g_step==GAME_GAME)&&(sysw->load < 250)) VSync(0);

        GsSwapDispBuff();

        if(sysw->clearf) GsSortClear(sysw->clearR,sysw->clearG,sysw->clearB,&(sysw->got[sysw->activebuff]));
        GsDrawOt(&(sysw->got[sysw->activebuff]));

        // pbhԂXV
        getpad();
        // select+start+L1+R1{^ŏI
        if(sysw->padw[PAD1].new == (PADselect|PADstart|PADL1|PADR1)) break;
        if(sysw->padw[PAD1].new == (PADR1|PADR2|PADL1|PADL2)){
        	DrawSync(0);
        	sysw->g_step = GAME_END;
        }

#if DEBUG
        // t[obt@`
        if (sysw->padw[PAD2].new & PADstart) Vframebuff();
#endif
    }

    VSync(0);
    ResetGraph(0);
    cd_stop();
    SsUtAllKeyOff(0);
    return 1;
}
